//
//  ViewController.m
//  ruleDemo
//
//  Created by HaiLai on 17/6/23.
//  Copyright © 2017年 HaiLai. All rights reserved.
//

#import "ViewController.h"

@interface ViewController ()
@property (weak, nonatomic) IBOutlet UIScrollView *ruleSV;
@property (weak, nonatomic) RuleView *ruleV;

@end

@implementation ViewController

#pragma mark - event
-(void)pinch:(UIPinchGestureRecognizer *)pinchGestureRecognizer
{
    UIView *view = self.ruleV;
    if (pinchGestureRecognizer.state == UIGestureRecognizerStateBegan || pinchGestureRecognizer.state == UIGestureRecognizerStateChanged) {
        NSLog(@"pinch scale %f",pinchGestureRecognizer.scale);
        CGFloat rulew = _ruleV.frame.size.width;
        CGFloat width = rulew * (CGFloat)pinchGestureRecognizer.scale;
        NSLog(@"rule width %f",width);
        if (width >= self.ruleSV.frame.size.width && width <= self.ruleSV.frame.size.width * 20) {
//            view.transform = CGAffineTransformScale(view.transform, pinchGestureRecognizer.scale, 1);
            view.width = width;
            _ruleSV.contentSize = CGSizeMake(width, 0);
        }
    }
}
#pragma mark - method
-(void)initilization
{
    RuleView *rule = [[RuleView alloc]initWithCount:30 andOriginalLength:self.ruleSV.frame.size.width];
    rule.frame = self.ruleSV.bounds;
    rule.backgroundColor = [UIColor lightGrayColor];
    self.ruleSV.contentSize = CGSizeMake(self.ruleSV.frame.size.width, 0);
    [self.ruleSV addSubview:rule];
    self.ruleV = rule;
    
    UIPinchGestureRecognizer *gesture = [[UIPinchGestureRecognizer alloc]initWithTarget:self action:@selector(pinch:)];
    self.ruleSV.scrollEnabled = YES;
    self.ruleSV.userInteractionEnabled = YES;
    [self.ruleSV addGestureRecognizer:gesture];
}
#pragma mark - life
- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view, typically from a nib.
    [self initilization];
}


- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}


@end


@interface RuleView ()
@property (nonatomic,assign) NSInteger count;
@property (nonatomic,assign) CGFloat originLength;
@end

@implementation RuleView

-(instancetype)initWithCount:(NSInteger)count andOriginalLength:(CGFloat)length
{
    if (self = [super init]) {
        self.count = count;
        self.originLength = length;
    }
    return self;
}

-(void)layoutSubviews
{
    [super layoutSubviews];
    
    for (UIView *view in self.subviews) {
        if (1024 == view.tag) {
            [view removeFromSuperview];
        }
    }
    
    for (NSInteger i = 0; i < _count; i++) {
        UIView *sign = [[UIView alloc]initWithFrame:CGRectMake(0, 0, 6, 6)];
        sign.tag = 1024;
        sign.backgroundColor = [UIColor redColor];
        CGPoint center = CGPointMake(i * self.frame.size.width / _count, self.frame.size.height / 2);
        sign.center = center;
//        sign.layer.cornerRadius = 3;
//        sign.clipsToBounds = YES;
        [self addSubview:sign];
        
        if (self.width > _originLength * 10) {
            if (i < _count) {
                for (NSInteger j = 0; j < 10; j++) {
                    UIView *sign = [[UIView alloc]initWithFrame:CGRectMake(0, 0, 4, 4)];
                    sign.tag = 1024;
                    sign.backgroundColor = [UIColor redColor];
                    CGPoint center = CGPointMake(i * self.frame.size.width / _count + j * self.frame.size.width / _count / 10, self.frame.size.height / 2);
                    sign.center = center;
                    sign.layer.cornerRadius = 2;
                    sign.clipsToBounds = YES;
                    [self addSubview:sign];
                }
            }
        }
    }
}

@end



@implementation UIView (Extension)
- (void)setX:(CGFloat)x
{
    CGRect frame = self.frame;
    frame.origin.x = x;
    self.frame = frame;
}

- (CGFloat)x
{
    return self.frame.origin.x;
}

- (void)setMaxX:(CGFloat)maxX
{
    self.x = maxX - self.width;
}

- (CGFloat)maxX
{
    return CGRectGetMaxX(self.frame);
}

- (void)setMaxY:(CGFloat)maxY
{
    self.y = maxY - self.height;
}

- (CGFloat)maxY
{
    return CGRectGetMaxY(self.frame);
}

- (void)setY:(CGFloat)y
{
    CGRect frame = self.frame;
    frame.origin.y = y;
    self.frame = frame;
}

- (CGFloat)y
{
    return self.frame.origin.y;
}

- (void)setCenterX:(CGFloat)centerX
{
    CGPoint center = self.center;
    center.x = centerX;
    self.center = center;
}

- (CGFloat)centerX
{
    return self.center.x;
}

- (void)setCenterY:(CGFloat)centerY
{
    CGPoint center = self.center;
    center.y = centerY;
    self.center = center;
}

- (CGFloat)centerY
{
    return self.center.y;
}

- (void)setWidth:(CGFloat)width
{
    CGRect frame = self.frame;
    frame.size.width = width;
    self.frame = frame;
}

- (CGFloat)width
{
    return self.frame.size.width;
}

- (void)setHeight:(CGFloat)height
{
    CGRect frame = self.frame;
    frame.size.height = height;
    self.frame = frame;
}

- (CGFloat)height
{
    return self.frame.size.height;
}

- (void)setSize:(CGSize)size
{
    CGRect frame = self.frame;
    frame.size = size;
    self.frame = frame;
}

- (CGSize)size
{
    return self.frame.size;
}


-(void)resetOrign:(CGPoint)orign
{
    [self setFrame:CGRectMake(orign.x, orign.y, self.frame.size.width, self.frame.size.height)];
}
-(void)resetSize:(CGSize)size
{
    [self setFrame:CGRectMake(self.frame.origin.x, self.frame.origin.y, size.width, size.height)];
}
@end
